﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="index.aspx.cs" Inherits="aspnet_swap_gridview_rows_columns_javascript_index" %>

<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Swap GridView Rows and Columns with JavaScript | YogiHosting Demo</title>
    <link rel="icon" type="image/png" href="http://www.yogihosting.com/wp-content/themes/yogi-yogihosting/Images/favicon.ico" />
    <style>
        body {
            background: #111 no-repeat;
            background-image: -webkit-gradient(radial, 50% 0, 150, 50% 0, 300, from(#444), to(#111));
        }

        h1, h2, h3 {
            text-align: center;
            color: #FFF;
        }

            h2 a {
                color: #0184e3;
                text-decoration: none;
            }

                h2 a:hover {
                    text-decoration: underline;
                }

            h3 a {
                color: #00e8ff;
                text-decoration: none;
            }

                h3 a:hover {
                    text-decoration: underline;
                }

        .container {
            width: 900px;
            margin: auto;
            color: #FFF;
            font-size: 25px;
        }

            .container h3 {
                font-size: 20px;
            }

        #content {
            position: relative;
            border: dashed 2px #CCC;
        }

        table {
            font-family: "Trebuchet MS", Arial, Helvetica, sans-serif;
            border-collapse: collapse;
            width: 100%;
        }

            table td, table th {
                border: 1px solid #ddd;
                padding: 8px;
            }

            table tr {
                background-color: #2549f6;
            }

            table th {
                padding-top: 12px;
                padding-bottom: 12px;
                text-align: left;
                background-color: #4CAF50;
                color: white;
            }

        h4 {
            margin:10px;
            text-align:center;
        }

        #reset, .swap {
            padding: 5px 10px;
            background: #4CAF50;
            border: none;
            color: #FFF;
            cursor: pointer;
        }

            #reset:hover, .swap:hover {
                color: #4CAF50;
                background: #FFF;
            }
    </style>
</head>
<body>
    <form id="form1" runat="server">
        <h1>Swap GridView Rows and Columns with JavaScript </h1>
        <h2>Important Link - <a href="http://www.yogihosting.com/jquery-each/">jQuery Each Method</a></h2>
        <h3>
            <a id="reset" onclick="location.reload();">Reset »</a>
        </h3>
        <div class="container">
            <div id="content">
                <asp:GridView ID="gridView" runat="server" AutoGenerateColumns="false">
                    <Columns>
                        <asp:BoundField DataField="Id" HeaderText="Id" />
                        <asp:TemplateField HeaderText="Name">
                            <ItemTemplate>
                                <asp:Label ID="nameLabel" runat="server" Text='<%#Bind("Name") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Quantity">
                            <ItemTemplate>
                                <asp:Label ID="TxtQuantity" runat="server" Text='<%# Bind("Quantity") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Price">
                            <ItemTemplate>
                                $<asp:Label ID="TxtPrice" runat="server" Text='<%# Bind("Price") %>'></asp:Label>
                            </ItemTemplate>
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Edit" ItemStyle-CssClass="editColumn">
                            <ItemTemplate>
                                <asp:Button ID="editButton" runat="server" Text="Edit"></asp:Button>
                            </ItemTemplate>
                        </asp:TemplateField>
                    </Columns>
                </asp:GridView>
                <h4>
                    <button class="swap" onclick="return Swap();">Swap</button>
                </h4>
            </div>
        </div>
        <script>
            function Swap() {
                var t = document.getElementsByTagName('tbody')[0],
                    r = t.getElementsByTagName('tr');
                table = document.createElement("table");

                for (i = 0; i < r.length; i++) {
                    for (j = 0; j < r[i].querySelectorAll('th,td').length; j++) {
                        if (i == 0) {
                            tem = document.createElement("tr");
                            clone = r[i].querySelectorAll('th,td')[j].cloneNode(true);
                            tem.appendChild(clone);
                            table.appendChild(tem)
                        }
                        else {
                            clone = r[i].querySelectorAll('th,td')[j].cloneNode(true);
                            table.getElementsByTagName("tr")[j].appendChild(clone);
                        }
                    }
                }
                document.getElementById("gridView").innerHTML = table.innerHTML;
                return false;
            }
        </script>
    </form>
</body>
</html>
